/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Quickfile extension for Thunderbird.
 *
 * The Initial Developer of the Original Code is Paul Tomlin.
 * Portions created by the Initial Developer are Copyright (C) 2005, 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Paul Tomlin
 *  Mark Shuttleworth
 *
 * ***** END LICENSE BLOCK ***** */

/* $Id: optionsShortcuts.js,v 1.2 2006/11/20 10:32:31 paultomlin Exp $ */

//const nsIPrefService = Components.interfaces.nsIPrefService;

var gShortcutsPane =
{
  _prefsService: Components.classes["@mozilla.org/preferences-service;1"]
                           .getService(nsIPrefService)
                           .getBranch("quickfile."),

  _modifiers: ['accel', 'alt', 'control', 'meta', 'shift'],

  onPaneLoad: function _onPaneLoad ()
  {
    this._updateTreeView();
  },

  onAvailableShortcutsTreeSelect: function _onAvailableShortcutsTreeSelect ()
  {
    var tree = document.getElementById('quickfileOptions.shortcuts.availableShortcutsTree');

    var shortcut = tree.view.getCellValue(tree.currentIndex, tree.columns[0]);
    var key = document.getElementById('pref.shortcuts.' + shortcut + '.key').value;
    var modifiers = document.getElementById('pref.shortcuts.' + shortcut + '.modifiers').value;

    document.getElementById('quickfileOptions.shortcuts.shortcutKey').value = key.toUpperCase();

    for (var i in this._modifiers) {
      document.getElementById('quickfileOptions.shortcuts.shortcutModifier.' + this._modifiers[i]).checked =
        (modifiers.indexOf(this._modifiers[i]) > -1)
    }
  },

  onShortcutKeyMenulistCommand: function _onShortcutKeyMenulistCommand ()
  {
    var tree = document.getElementById('quickfileOptions.shortcuts.availableShortcutsTree');
    var shortcut = tree.view.getCellValue(tree.currentIndex, tree.columns[0]);

    document.getElementById('pref.shortcuts.' + shortcut + '.key').value =
      document.getElementById('quickfileOptions.shortcuts.shortcutKey').value;

    this._updateTreeView();
  },

  onShortcutModifierCommand: function _onShortcutModifierCommand ()
  {
    var tree = document.getElementById('quickfileOptions.shortcuts.availableShortcutsTree');
    var shortcut = tree.view.getCellValue(tree.currentIndex, tree.columns[0]);

    var modifiers = [];
    for (var i in this._modifiers) {
      if (document.getElementById('quickfileOptions.shortcuts.shortcutModifier.' + this._modifiers[i]).checked)
        modifiers.push(this._modifiers[i]);
    }

    document.getElementById('pref.shortcuts.' + shortcut + '.modifiers').value = modifiers.join(' ');

    this._updateTreeView();
  },

  _updateTreeView: function __updateTreeView ()
  {
    var tree = document.getElementById('quickfileOptions.shortcuts.availableShortcutsTree');
    var rowCount = tree.view.rowCount;

    for (var i = 0; i < rowCount; i++) {
      var shortcut = tree.view.getCellValue(i, tree.columns[0]);
      var key = document.getElementById('pref.shortcuts.' + shortcut + '.key').value;
      var modifiers = document.getElementById('pref.shortcuts.' + shortcut + '.modifiers').value;

      if (key.length) {
        var text = modifiers.toUpperCase().split(' ').sort().join(' + ');
        if (text.length)
          text += ' + ';
        text += key.toUpperCase();

        tree.view.setCellText(i, tree.columns[1], text);
      }
      else {
        tree.view.setCellText(i, tree.columns[1], 'disabled');
      }
    }
  }
};
